aubio 0.4.2~alpha

- Main Page
- Data Structures
- Files
- Examples

- File List
- Globals

filterbank.h
Go to the documentation of this file.
1 /*
2 Copyright (C) 2007-2013 Paul Brossier <piem@aubio.org>
3 and Amaury Hazan <ahazan@iua.upf.edu>
4
5 This file is part of aubio.
6
7 aubio is free software: you can redistribute it and/or modify
8 it under the terms of the GNU General Public License as published by
9 the Free Software Foundation, either version 3 of the License, or
10 (at your option) any later version.
11
12 aubio is distributed in the hope that it will be useful,
13 but WITHOUT ANY WARRANTY; without even the implied warranty of
14 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 GNU General Public License for more details.
16
17 You should have received a copy of the GNU General Public License
18 along with aubio. If not, see <http://www.gnu.org/licenses/>.
19
20 */
21
22 /** \file
23
24 Filterbank object
25
26 General-purpose spectral filterbank object.
27
28 \example spectral/test-filterbank.c
29
30 */
31
32 #ifndef _AUBIO_FILTERBANK_H
33 #define _AUBIO_FILTERBANK_H
34
35 #ifdef __cplusplus
36 extern "C"
37 {
38 #endif
39
40 /** filterbank object
41
42 This object stores a matrix of spectral filter coefficients.
43
44 */
45 typedef struct _aubio_filterbank_t aubio_filterbank_t;
46
47 /** create filterbank object
48
49 \param n_filters number of filters to create
50 \param win_s size of analysis buffer (and length the FFT transform)
51
52 */
53 aubio_filterbank_t *new_aubio_filterbank (uint_t n_filters, uint_t win_s);
54
55 /** destroy filterbank object
56
57 \param f filterbank object, as returned by new_aubio_filterbank()
58
59 */
60 void del_aubio_filterbank (aubio_filterbank_t * f);
61
62 /** compute filterbank
63
64 \param f filterbank object, as returned by new_aubio_filterbank()
65 \param in input spectrum containing an input spectrum of length `win_s`
66 \param out output vector containing the energy found in each band, `nfilt` output values
67
68 */
69 void aubio_filterbank_do (aubio_filterbank_t * f, cvec_t * in, fvec_t * out);
70
71 /** return a pointer to the matrix object containing all filter coefficients
72
73 \param f filterbank object, as returned by new_aubio_filterbank()
74
75 */
76 fmat_t *aubio_filterbank_get_coeffs (aubio_filterbank_t * f);
77
78 /** copy filter coefficients to the filterbank
79
80 \param f filterbank object, as returned by new_aubio_filterbank()
81 \param filters filter bank coefficients to copy from
82
83 */
84 uint_t aubio_filterbank_set_coeffs (aubio_filterbank_t * f, fmat_t * filters);
85
86 #ifdef __cplusplus
87 }
88 #endif
89
90 #endif /* _AUBIO_FILTERBANK_H */
aubio_filterbank_t
struct _aubio_filterbank_t aubio_filterbank_t
filterbank object
Definition: filterbank.h:45
aubio_filterbank_get_coeffs
fmat_t * aubio_filterbank_get_coeffs(aubio_filterbank_t *f)
return a pointer to the matrix object containing all filter coefficients
del_aubio_filterbank
void del_aubio_filterbank(aubio_filterbank_t *f)
destroy filterbank object
aubio_filterbank_set_coeffs
uint_t aubio_filterbank_set_coeffs(aubio_filterbank_t *f, fmat_t *filters)
copy filter coefficients to the filterbank
aubio_filterbank_do
void aubio_filterbank_do(aubio_filterbank_t *f, cvec_t *in, fvec_t *out)
compute filterbank
new_aubio_filterbank
aubio_filterbank_t * new_aubio_filterbank(uint_t n_filters, uint_t win_s)
create filterbank object
fvec_t
Buffer for real data.
Definition: fvec.h:67
cvec_t
Vector of real-valued phase and spectrum data.
Definition: cvec.h:63
uint_t
unsigned int uint_t
unsigned integer
Definition: types.h:60
fmat_t
Buffer for real data.
Definition: fmat.h:40